#ifndef RetinaFaceDetector_H
#define RetinaFaceDetector_H
#pragma once
#include <string.h>
#include <vector>
#include <iostream>
#include <typeinfo>
#include "ANSEngineCommon.h"
#include "fastdeploy/vision.h"


namespace ANSCENTER {
    class ANSENGINE_API ANSRETINAFD :public ANSFDBase {
    public:
        virtual bool Initialize(std::string licenseKey, ModelConfig modelConfig, const std::string& modelZipFilePath, const std::string& modelZipPassword, std::string& labelMap) override;
        virtual bool LoadModel(const std::string& modelZipFilePath, const std::string& modelZipPassword)override;
        bool OptimizeModel(bool fp16, std::string& optimizedModelFolder);
        std::vector<Object> RunInference(const cv::Mat& input);
        std::vector<Object> RunInference(const cv::Mat& input, const std::string& camera_id);
        
        bool Destroy();
        ~ANSRETINAFD();
    private:
        ModelConfig         _modelConfig;
        std::string        _modelFilePath;
        std::unique_ptr<fastdeploy::vision::facedet::RetinaFace>_faceDectector = nullptr;

    };
}
#endif